Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 4901)
+++ palm/trunk/SOURCE/modules.f90	(revision 1)
@@ -1267,27 +614,123 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Definition of grid spacings.
-!--------------------------------------------------------------------------------------------------!
+
+
+ MODULE cpulog
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Definition of variables for cpu-time measurements
+!------------------------------------------------------------------------------!
+
+    REAL ::  initial_wallclock_time
+
+    TYPE logpoint
+       REAL               ::  isum, ivect, mean, mtime, mtimevec, sum, vector
+       INTEGER            ::  counts
+       CHARACTER (LEN=20) ::  place
+    END TYPE logpoint
+
+    TYPE(logpoint), DIMENSION(100) ::  log_point = logpoint( 0.0, 0.0, 0.0,   &
+                                       0.0, 0.0, 0.0, 0.0, 0, ' ' ),          &
+                                       log_point_s = logpoint( 0.0, 0.0, 0.0, &
+                                       0.0, 0.0, 0.0, 0.0, 0, ' ' )
+
+    SAVE
+
+ END MODULE cpulog
+
+
+
+
+ MODULE dvrp_variables
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Definition of variables used with dvrp-software
+!------------------------------------------------------------------------------!
+
+    CHARACTER (LEN=10) ::  dvrp_output = 'rtsp'
+
+    CHARACTER (LEN=20), DIMENSION(10) ::  mode_dvrp = &
+                                     (/ ( '                    ', i9 = 1,10 ) /)
+
+    CHARACTER (LEN=80) ::  dvrp_directory = 'default',                    &
+                           dvrp_file      = 'default',                    &
+                           dvrp_host      = 'origin.rvs.uni-hannover.de', &
+                           dvrp_password  = '********',                   &
+                           dvrp_username  = ' '
+
+    INTEGER ::  dvrp_colourtable_entries = 4, islice_dvrp, nx_dvrp, ny_dvrp, &
+                nz_dvrp
+
+    INTEGER, DIMENSION(10) ::  slicer_position_dvrp
+
+    LOGICAL ::  cyclic_dvrp = .FALSE., lock_steering_update = .FALSE., &
+                use_seperate_pe_for_dvrp_output = .FALSE.
+
+    REAL    ::  superelevation = 1.0, superelevation_x = 1.0, &
+                superelevation_y = 1.0
+
+#if defined( __decalpha )
+    REAL, DIMENSION(2,10)  ::  slicer_range_limits_dvrp = (/ &
+                                -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, &
+                                -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, &
+                                -1.0, 1.0, -1.0, 1.0 /)
+
+    REAL, DIMENSION(2,100) ::  interval_values_dvrp, interval_h_dvrp =       &
+                               (/ 270.0, 225.0, 225.0, 180.0, 70.0, 25.0,    &
+                                  25.0, -25.0, ( 0.0, i9 = 1, 192 ) /),      &
+                               interval_l_dvrp = 0.5, interval_s_dvrp = 1.0, &
+                               interval_a_dvrp = 0.0
+#else
+    REAL, DIMENSION(2,10)  ::  slicer_range_limits_dvrp
+
+    REAL, DIMENSION(2,100) ::  interval_values_dvrp, interval_h_dvrp,        &
+                               interval_l_dvrp = 0.5, interval_s_dvrp = 1.0, &
+                               interval_a_dvrp = 0.0
+
+    DATA  slicer_range_limits_dvrp / -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, &
+                                     -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, &
+                                     -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, &
+                                     -1.0, 1.0 /
+
+    DATA  interval_h_dvrp / 270.0, 225.0, 225.0, 180.0, 70.0, 25.0, &
+                            25.0, -25.0, 192 * 0.0 /
+#endif
+
+    REAL, DIMENSION(:), ALLOCATABLE ::  xcoor_dvrp, ycoor_dvrp, zcoor_dvrp
+
+    TYPE steering
+       CHARACTER (LEN=20) ::  name
+       REAL               ::  min, max
+       INTEGER            ::  imin, imax
+    END TYPE steering
+
+    TYPE(steering), DIMENSION(:), ALLOCATABLE ::  steering_dvrp
+
+    SAVE
+
+ END MODULE dvrp_variables
+
+
+
+
  MODULE grid_variables
 
-    USE kinds
-
-    REAL(wp) ::  ddx          !< 1/dx
-    REAL(wp) ::  ddx2         !< 1/dx2
-    REAL(wp) ::  dx = 1.0_wp  !< horizontal grid size (along x-direction)
-    REAL(wp) ::  dx2          !< dx*dx
-    REAL(wp) ::  ddy          !< 1/dy
-    REAL(wp) ::  ddy2         !< 1/dy2
-    REAL(wp) ::  dy = 1.0_wp  !< horizontal grid size (along y-direction)
-    REAL(wp) ::  dy2          !< dy*dy
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddx2_mg  !< 1/dx_l**2 (dx_l: grid spacing along x on different multigrid level)
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddy2_mg  !< 1/dy_l**2 (dy_l: grid spacing along y on different multigrid level)
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zu_s_inner  !< height of topography top on scalar grid
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zw_w_inner  !< height of topography top on w grid
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Definition of grid spacings
+!------------------------------------------------------------------------------!
+
+    REAL ::  ddx, ddx2, dx = 1.0, dx2, ddy, ddy2, dy = 1.0, dy2
+
+    REAL, DIMENSION(:), ALLOCATABLE ::  ddx2_mg, ddy2_mg
+
+    REAL, DIMENSION(:,:), ALLOCATABLE ::  fwxm, fwxp, fwym, fwyp, fxm, fxp, &
+                                          fym, fyp, wall_e_x, wall_e_y, &
+                                          wall_u, wall_v, wall_w_x, wall_w_y
 
     SAVE
@@ -1296,87 +739,27 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Definition of array bounds, number of gridpoints, and wall flag arrays.
-!--------------------------------------------------------------------------------------------------!
+
+
  MODULE indices
 
-    USE kinds
-
-    INTEGER(iwp) ::  nbgp = 3       !< number of boundary ghost points
-    INTEGER(iwp) ::  ngp_sums       !< number of vertical profile grid points time number of output profiles - used for allreduce
-                                    !< statements in MPI calls
-    INTEGER(iwp) ::  ngp_sums_ls    !< number of vertical profile grid points time number of large-scale forcing profiles - used for
-                                    !< allreduce statements in MPI calls
-    INTEGER(iwp) ::  nnx            !< number of subdomain grid points in x-direction
-    INTEGER(iwp) ::  nx = 0         !< nx+1 = total number of grid points in x-direction
-    INTEGER(iwp) ::  nx_a           !< in coupled atmosphere-ocean runs: total number of grid points along x (atmosphere)
-    INTEGER(iwp) ::  nx_o           !< in coupled atmosphere-ocean runs: total number of grid points along x (ocean)
-    INTEGER(iwp) ::  nxl            !< left-most grid index of subdomain (excluding ghost points)
-    INTEGER(iwp) ::  nxlg           !< left-most grid index of subdomain (including ghost points)
-    INTEGER(iwp) ::  nxlu           !< =nxl+1 (at left domain boundary with inflow from left), else =nxl
-                                    !< (used for u-velocity component)
-    INTEGER(iwp) ::  nxr            !< right-most grid index of subdomain (excluding ghost points)
-    INTEGER(iwp) ::  nxrg           !< right-most grid index of subdomain (including ghost points)
-    INTEGER(iwp) ::  nx_on_file     !< nx of previous run in job chain
-    INTEGER(iwp) ::  nny            !< number of subdomain grid points in y-direction
-    INTEGER(iwp) ::  ny = 0         !< ny+1 = total number of grid points in y-direction
-    INTEGER(iwp) ::  ny_a           !< in coupled atmosphere-ocean runs: total number of grid points along y (atmosphere)
-    INTEGER(iwp) ::  ny_o           !< in coupled atmosphere-ocean runs: total number of grid points along y (ocean)
-    INTEGER(iwp) ::  nyn            !< north-most grid index of subdomain (excluding ghost points)
-    INTEGER(iwp) ::  nyng           !< north-most grid index of subdomain (including ghost points)
-    INTEGER(iwp) ::  nys            !< south-most grid index of subdomain (excluding ghost points)
-    INTEGER(iwp) ::  nysg           !< south-most grid index of subdomain (including ghost points)
-    INTEGER(iwp) ::  nysv           !< =nys+1 (at south domain boundary with inflow from south), else =nys
-                                    !< (used for v-velocity component)
-    INTEGER(iwp) ::  ny_on_file     !< ny of previous run in job chain
-    INTEGER(iwp) ::  nnz            !< number of subdomain grid points in z-direction
-    INTEGER(iwp) ::  nz = 0         !< total number of grid points in z-direction
-    INTEGER(iwp) ::  nzb            !< bottom grid index of computational domain
-    INTEGER(iwp) ::  nzb_diff       !< will be removed
-    INTEGER(iwp) ::  nzb_max        !< vertical index of topography top
-    INTEGER(iwp) ::  nzt            !< nzt+1 = top grid index of computational domain
-    INTEGER(iwp) ::  topo_min_level !< minimum topography-top index (usually equal to nzb)
-
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_2dh       !< number of grid points of a horizontal cross section through the
-                                                              !< total domain
-    INTEGER(idp), DIMENSION(:), ALLOCATABLE ::  ngp_3d        !< number of grid points of the total domain
-    INTEGER(idp), DIMENSION(:), ALLOCATABLE ::  ngp_3d_inner  !< ! need to have 64 bit for grids > 2E9
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nxl_mg        !< left-most grid index of subdomain on different multigrid level
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nxr_mg        !< right-most grid index of subdomain on different multigrid level
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nyn_mg        !< north-most grid index of subdomain on different multigrid level
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nys_mg        !< south-most grid index of subdomain on different multigrid level
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nzt_mg        !< top-most grid index of subdomain on different multigrid level
-
-
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mg_loc_ind        !< internal array to store index bounds of all PEs of that
-                                                                    !< multigrid level where data is collected to PE0
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  ngp_2dh_outer     !< number of horizontal grid points which are non-topography and
-                                                                    !< non-surface-bounded
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  ngp_2dh_s_inner   !< number of horizontal grid points which are non-topography
-
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_1   !< topograpyh masking flag on multigrid level 1
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_2   !< topograpyh masking flag on multigrid level 2
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_3   !< topograpyh masking flag on multigrid level 3
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_4   !< topograpyh masking flag on multigrid level 4
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_5   !< topograpyh masking flag on multigrid level 5
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_6   !< topograpyh masking flag on multigrid level 6
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_7   !< topograpyh masking flag on multigrid level 7
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_8   !< topograpyh masking flag on multigrid level 8
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_9   !< topograpyh masking flag on multigrid level 9
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_10  !< topograpyh masking flag on multigrid level 10
-
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  advc_flags_m            !< flags used to degrade order of advection scheme for
-                                                                            !< momentum
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  advc_flags_s            !< flags used to degrade order of advection scheme for
-                                                                            !< scalar quantities
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  topo_top_ind            !< precalculated topography top indices
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  wall_flags_static_0     !< flags to mask topography and surface-bounded grid
-                                                                            !< points
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  wall_flags_total_0      !< merged array, which contains the static and dynamic
-                                                                            !< flags
-
-    INTEGER(iwp), DIMENSION(:,:,:), POINTER ::  flags  !< pointer to wall_flags_1-10
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Definition of array bounds and number of gridpoints
+!------------------------------------------------------------------------------!
+
+    INTEGER ::  ngp_sums, nnx, nx = 0, nxa, nxl, nxr, nxra, nny, ny = 0, nya,  &
+                nyn, nyna, nys, nnz, nz = 0, nza, nzb, nzb_diff, nzt, nzta,    &
+                uxrp = 0, vynp = 0
+
+    INTEGER, DIMENSION(:), ALLOCATABLE ::                                      &
+                ngp_2dh, ngp_3d, ngp_3d_inner,                                 &
+                nnx_pe, nny_pe, nxl_mg, nxr_mg, nyn_mg, nys_mg, nzt_mg
+
+    INTEGER, DIMENSION(:,:), ALLOCATABLE ::                                    &
+                ngp_2dh_outer, mg_loc_ind, nzb_diff_s_inner, nzb_diff_s_outer, &
+                nzb_diff_u, nzb_diff_v, nzb_inner, nzb_outer, nzb_s_inner,     &
+                nzb_s_outer, nzb_u_inner, nzb_u_outer, nzb_v_inner,            &
+                nzb_v_outer, nzb_w_inner, nzb_w_outer, nzb_2d
 
     SAVE
@@ -1385,42 +768,41 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Interfaces for special subroutines which use optional parameters.
-!--------------------------------------------------------------------------------------------------!
+
+
  MODULE interfaces
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Interfaces for special subroutines which use optional parameters
+!------------------------------------------------------------------------------!
+
     INTERFACE
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> @todo Missing subroutine description.
-!--------------------------------------------------------------------------------------------------!
-       SUBROUTINE global_min_max ( i1, i2, j1, j2, k1, k2, array, mode, offset, result, result_ijk,&
-                                   result1, result1_ijk )
-
-          USE kinds
-
-          CHARACTER (LEN=*), INTENT(IN) ::  mode                      !< mode of global min/max function: can be 'min', 'max',
-                                                                      !< 'minmax', 'abs', or 'absoff'
-
-          INTEGER(iwp), INTENT(IN)      ::  i1                        !< internal index of min/max function
-          INTEGER(iwp), INTENT(IN)      ::  i2                        !< internal index of min/max function
-          INTEGER(iwp), INTENT(IN)      ::  j1                        !< internal index of min/max function
-          INTEGER(iwp), INTENT(IN)      ::  j2                        !< internal index of min/max function
-          INTEGER(iwp), INTENT(IN)      ::  k1                        !< internal index of min/max function
-          INTEGER(iwp), INTENT(IN)      ::  k2                        !< internal index of min/max function
-
-          INTEGER(iwp)                  ::  result_ijk(3)             !< grid index result of min/max function
-          INTEGER(iwp), OPTIONAL        ::  result1_ijk(3)            !< optional grid index result of min/max function
-
-          REAL(wp)                      ::  offset                    !< min/max function calculates absolute value with respect to
-                                                                      !< an offset
-          REAL(wp)                      ::  result                    !< result of min/max function
-          REAL(wp), OPTIONAL            ::  result1                   !< optional result of min/max function
-
-          REAL(wp), INTENT(IN)          ::  array(i1:i2,j1:j2,k1:k2)  !< input array of min/max function
+       SUBROUTINE cpu_log( log_event, place, modus, barrierwait )
+
+          USE cpulog
+
+          CHARACTER (LEN=*)           ::  modus, place
+          CHARACTER (LEN=*), OPTIONAL ::  barrierwait
+          TYPE(logpoint)              ::  log_event
+
+       END SUBROUTINE cpu_log
+
+    END INTERFACE
+
+
+
+    INTERFACE
+
+       SUBROUTINE global_min_max ( i1, i2, j1, j2, k1, k2, feld, mode, wert, &
+                                   wert_ijk, wert1, wert1_ijk )
+          CHARACTER (LEN=*), INTENT(IN) ::  mode
+          INTEGER, INTENT(IN)           ::  i1, i2, j1, j2, k1, k2
+          INTEGER                       ::  wert_ijk(3)
+          INTEGER, OPTIONAL             ::  wert1_ijk(3)
+          REAL                          ::  wert
+          REAL, OPTIONAL                ::  wert1
+          REAL, INTENT(IN)              ::  feld(i1:i2,j1:j2,k1:k2)
 
        END SUBROUTINE global_min_max
@@ -1433,25 +815,20 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Interfaces for subroutines with pointer arguments called in prognostic_equations.
-!--------------------------------------------------------------------------------------------------!
+
  MODULE pointer_interfaces
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+! Interfaces for subroutines with pointer arguments called in
+! prognostic_equations
+!------------------------------------------------------------------------------!
+
     INTERFACE
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> @todo Missing subroutine description.
-!--------------------------------------------------------------------------------------------------!
        SUBROUTINE advec_s_bc( sk, sk_char )
 
-          USE kinds
-
-          CHARACTER (LEN=*), INTENT(IN) ::  sk_char  !< string for treated scalar in Bott-Chlond scheme
-
-          REAL(wp), DIMENSION(:,:,:), POINTER ::  sk  !< treated scalar array in Bott-Chlond scheme
+          CHARACTER (LEN=*), INTENT(IN)   ::  sk_char
+          REAL, DIMENSION(:,:,:), POINTER ::  sk
 
        END SUBROUTINE advec_s_bc
@@ -1459,4 +836,5 @@
     END INTERFACE
 
+
     SAVE
 
